precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform vec2 imageSize;//screenSize
uniform vec2 frameSize;
uniform vec4 rect;//{l,t,r,b}
void main()
{
    vec2 uv = textureCoordinate * imageSize;
    float l = rect.x, t = rect.y, r = rect.z, b = rect.w;
    float dx = imageSize.x - frameSize.x;
    if(uv.x < l * frameSize.x) {
        uv.x /= frameSize.x;
    } else if(uv.x < r * frameSize.x + dx) {
        float delta = dx / (r - l) / frameSize.x;
        uv.x = l + (uv.x - l * frameSize.x) / (1.0 + delta) / frameSize.x;
    } else {
        uv.x -= dx;
        uv.x /= frameSize.x;
    }

    float dy = imageSize.y - frameSize.y;
    if(uv.y < t * frameSize.y) {
        uv.y /= frameSize.y;
    } else if(uv.y < b * frameSize.y + dy) {
        float delta = dy / (b - t) / frameSize.y;
        uv.y = t + (uv.y - t * frameSize.y) / (1.0 + delta) / frameSize.y;
    } else {
        uv.y -= dy;
        uv.y /= frameSize.y;
    }
    gl_FragColor = texture2D(inputImageTexture, uv);
}