precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float offset;
uniform vec2 imageSize;
const vec4 BG_DEFAULT_COLOR = vec4(0.0,0.0,0.0,1.0);
void main()
{
    float imageRatio = imageSize.x / imageSize.y;
    vec2 uv = textureCoordinate;
    if(imageRatio >= 1.0) {
        float offsetX = 0.025;
        float keepArea = 0.95;
        uv.x -= offsetX;//95%(-0.025~0.975) => 0~0.95
        uv.y -= offset;
        if(uv.x >= 0.0 && uv.x <= keepArea) {
            uv /= keepArea;
            if(uv.y > 1.0) uv.y -= 1.0;
            if(uv.y < 0.0) uv.y += 1.0;
            gl_FragColor = texture2D(inputImageTexture, uv);
        } else {
            gl_FragColor = BG_DEFAULT_COLOR;
        }
    } else {
        float offsetY = 0.025;
        float keepArea = 0.95;
        uv.x -= offset;
        uv.y -= offsetY;//95%(-0.025~0.975) => 0~0.95
        if(uv.y >= 0.0 && uv.y <= keepArea) {
            uv /= keepArea;
            if(uv.x > 1.0) uv.x -= 1.0;
            if(uv.x < 0.0) uv.x += 1.0;
            gl_FragColor = texture2D(inputImageTexture, uv);
        } else {
            gl_FragColor = BG_DEFAULT_COLOR;
        }
    }
}