precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform float edge;
uniform float range;
uniform vec3 color;

float lum(vec3 color) {
    return dot(color, vec3(0.299,0.587,0.114));
}

void main()
{
    vec2 uv = textureCoordinate;
    vec4 col = texture2D(inputImageTexture, uv);
    float lum = lum(col.rgb);
    col = vec4(vec3(smoothstep(edge, edge + range, lum)), col.a);
    col.rgb *= color;
    gl_FragColor = col;
}