precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
varying vec2 textureCoordinate2;
uniform sampler2D inputImageTexture2;

uniform vec2 inputSize;
uniform float effectValue;

void main()
{
    vec2 uv = textureCoordinate;
    vec2 textureSize = inputSize;
    float a = textureSize.x < textureSize.y ? textureSize.y*effectValue :  textureSize.x*effectValue;

    float b = textureSize.x < textureSize.y ? textureSize.x*effectValue :  textureSize.y*effectValue;

    vec2 currentCoordinate = textureSize* (textureCoordinate - 0.5);
    float  ellipseX = pow(currentCoordinate.x, 2.0)/ pow(a, 2.0) + pow(currentCoordinate.y, 2.0)/ pow(b, 2.0);

    float  ellipseY = pow(currentCoordinate.y, 2.0)/ pow(a, 2.0) + pow(currentCoordinate.x, 2.0)/ pow(b, 2.0);

    float  ellipse = textureSize.x < textureSize.y ? ellipseY :  ellipseX;

    vec4 originalColror = texture2D(inputImageTexture, uv);
    vec4 brightColor = texture2D(inputImageTexture2, uv);

    gl_FragColor = mix(brightColor, originalColror, smoothstep(1.7, 1.0, ellipse));
}