precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D exposeTexture;
uniform sampler2D maskTexture;
void main()
{
    vec2 uv = textureCoordinate;

    vec4 originalColor = texture2D(inputImageTexture, uv);
    vec4 exposeColor = texture2D(exposeTexture, uv);
    vec4 maskColor = texture2D(maskTexture, uv);

    maskColor.rgb *= maskColor.a;
    float luminance = dot(vec3(0.299,0.587,0.114), maskColor.rgb);
    vec4 resultImage = mix(originalColor, exposeColor, luminance);

    gl_FragColor = resultImage;
}