precision highp float;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform vec2 inputSize;
uniform float effectValue;

void main()
{
    vec2 uv = textureCoordinate;
    vec2 textureSize = inputSize;

    vec4 originalColor = texture2D(inputImageTexture, uv);
    float luminance = dot(vec3(0.2126,0.2126,0.7152), originalColor.rgb);

    vec4 result = originalColor;
    if(luminance > 0.5){
        int kSize = int(effectValue);
        vec3 avg = vec3(0.0);
        for (int i=-kSize; i <= kSize; ++i) {
            for (int j = -kSize; j <= kSize; ++j) {
                avg = avg +texture2D(inputImageTexture, (uv + vec2(float(i), float(j))/textureSize.xy)).xyz;
            }
        }
        int area = (2*kSize + 1) * (2*kSize + 1);
        avg = avg.xyz/vec3(area);
        result = vec4(avg,originalColor.a);
    }
    gl_FragColor = result;
}